//=============================================================================
// File: gnutultraokmsg.h
// Author: Andre Dufour
//
// Class type: concrete
// Description: structure to contain the details of a ultraok message.
//=============================================================================

#ifndef __GNUTULTRAOKMSG_H__
#define __GNUTULTRAOKMSG_H__

#include "gnutconnectmsgbc.h"
#include "gnut_types.h"

class GnutCoord;

//=============================================================================
class GnutUltraOkMsg : public GnutConnectMsgBC
{
public:
    // = FOUNDATION

    // Build structure from user input.
    GnutUltraOkMsg(const GnutCoord& aCoord, double aError);

    // Build structure from packet.
    GnutUltraOkMsg(const void* aMem);

    virtual ~GnutUltraOkMsg(void);

private:
    // = FOUNDATION

    // Disable copy constructor and assignment operator
    GnutUltraOkMsg(const GnutUltraOkMsg&);
    GnutUltraOkMsg& operator=(const GnutUltraOkMsg&);
};
//=============================================================================
#endif /* __GNUTULTRAOKMSG_H__ */

