//=============================================================================
// File: gnutokmsg.h
// Author: Andre Dufour
//
// Class type: concrete
// Description: structure to contain the details of a ok message.
//=============================================================================

#ifndef __GNUTOKMSG_H__
#define __GNUTOKMSG_H__

#include "gnutconnectmsgbc.h"
#include "gnut_types.h"

class GnutCoord;

//=============================================================================
class GnutOkMsg : public GnutConnectMsgBC
{
public:
    // = FOUNDATION

    // Build structure from user input.
    GnutOkMsg(const GnutCoord& aCoord, double aError);

    // Build structure from packet.
    GnutOkMsg(const void* aMem);

    virtual ~GnutOkMsg(void);

private:
    // = FOUNDATION

    // Disable copy constructor and assignment operator
    GnutOkMsg(const GnutOkMsg&);
    GnutOkMsg& operator=(const GnutOkMsg&);
};
//=============================================================================
#endif /* __GNUTOKMSG_H__ */

