// File: leaf.h
// Original by Qi He
// Modified by Andre Dufour

#ifndef __LEAF_H__
#define __LEAF_H__

#include "gnut_types.h"
#include "gnutellaapp.h"

//=============================================================================
/* Leaf Gnutella Application */
class Leaf: public GnutellaApp 
{
public:
    // = FOUNDATION

    Leaf(NodeAddr_t aAddr);
    virtual ~Leaf(void);


    // = ACTION

    virtual void bootstrap();
    virtual bool avail(EPeerType aType) const;
    virtual void disconnect(NodeAddr_t aPeer);


private:
    // = FOUNDATION

    // Disable copy constructor and assignment operator
    Leaf(const Leaf&);
    Leaf& operator=(const Leaf&);
};
//=============================================================================

#endif /* __LEAF_H__ */

